//========================================================== IBJgrd.h
//
// Grid Functions
// ==============
//
// Copyright (C) Dr. Lutz Janicke, Dunum, Germany, 1999
// email: lj@janicke.de
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// history:
//
// last change: 98-07-31  lj
//
//==================================================================

#ifndef  IBJGRD_INCLUDE
#define  IBJGRD_INCLUDE

#ifndef     IBJARY_INCLUDE
  #include "IBJary.h"
#endif

#define  GRD_XLOW  0x01
#define  GRD_YLOW  0x02
#define  GRD_SLOW  0x04
#define  GRD_XHGH  0x10
#define  GRD_YHGH  0x20
#define  GRD_SHGH  0x40
#define  GRD_OUT   0x77

typedef struct { 
  float x0, y0, x1, y1, s0, s1, dd, *ss;
  float sh, zh;
  int flag, nx, ny, nz;
  ARYDSC *pbp, *pbm;
  ARYDSC bpdsc, bmdsc;
  }  GRDDEFREC;

#ifndef  GRDLOCREC_TYPE
#define  GRDLOCREC_TYPE
typedef struct {
  float x, y, z, s;
  float a, b, c;
  int   i, j, k;
  int flag;
  }  GRDLOCREC;
#endif

extern GRDDEFREC *pGrd;

int GrdInit( void )
  ;
int GrdDefK( int grdnum, float x0, float y0, float x1, float y1,
  float dd, int nz, float *ss, float sh, float zh )
  ;
int GrdSet( int gn )
  ;
int GrdI( float x )
  ;
int GrdJ( float y )
  ;
int GrdK( float s )
  ;
int GrdLoc2( float x, float y, 
int *pi, int *pj, float *pxi, float *peta, int *pl )
  ;
float GrdBij( int i, int j, float xi, float eta, int l )
  ;
float GrdBxy( float x, float y )
  ;
float GrdS( float x, float y, float z )
  ;
int GrdClcS( float x, float y, float *pz, float *ps )
  ;
int GrdOut( float x, float y, float s )
  ;
int GrdZ( float x, float y, float s, float *pz )
  ;
int GrdLoc3( float x, float y, float z, GRDLOCREC *ploc, int *pl )
  ;
float GrdZp( int i, int j, int k )
  ;
float GrdZm( int i, int j, int k )
  ;
VECTOR GrdVp( int i, int j, int k )
  ;
VECTOR GrdVm( int i, int j, int k )
  ;
float GrdS2Zij( int i, int j )
  ;
float GrdS2Z( float x, float y )
  ;
float GrdDp( int i, int j, int k )
  ;
float GrdDm( int i, int j, int k )
  ;
float GrdVol( int i, int j, int k )
  ;
float GrdArX( int i, int j, int k )
  ;
float GrdArY( int i, int j, int k )
  ;
VECTOR GrdNrmL( int i, int j, int k, int l )
  ;
int GrdNrm( int i, int j, int k, 
VECTOR *p1, VECTOR *p2, VECTOR *p3, VECTOR *p4 )
  ;
int GrdI3( GRDLOCREC loc, ARYDSC *pa, float *p )
  ;
int GrdI1X( GRDLOCREC loc, ARYDSC *pa, float *p )
  ;
int GrdI1Y( GRDLOCREC loc, ARYDSC *pa, float *p )
  ;
int GrdI1Z( GRDLOCREC loc, ARYDSC *pa, float *p )
  ;
int GrdMx( int i, int j, int k, ARYDSC *pa, float *p )
  ;
int GrdMy( int i, int j, int k, ARYDSC *pa, float *p )
  ;
int GrdMz4( int i, int j, int k, ARYDSC *pap, ARYDSC *pam,
float *p1, float *p2, float *p3, float *p4 )
  ;
int GrdMz( int i, int j, int k, ARYDSC *pap, ARYDSC *pam, float *p )
  ;
int GrdMv( int i, int j, int k, ARYDSC *pap, ARYDSC *pam, float *p )
  ;
float GrdDivV( int i, int j, int k, ARYDSC *pap, ARYDSC *pam )
  ;
VECTOR GrdDivM( int i, int j, int k, ARYDSC *pap, ARYDSC *pam )
  ;

#endif 
